Index: branches/encoders/code/projects/libwireless/lib/wireless.c
===================================================================
--- branches/encoders/code/projects/libwireless/lib/wireless.c	(revision 1344)
+++ branches/encoders/code/projects/libwireless/lib/wireless.c	(revision 1345)
@@ -1,3 +1,37 @@
+/**
+ * Copyright (c) 2007 Colony Project
+ *
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ *
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+/**
+ * @file wireless.c
+ * @brief Wireless Library Implementation
+ *
+ * Implementation of the wireless library.
+ *
+ * @author Brian Coltin, Colony Project, CMU Robotics Club
+ **/
+
 #include "wireless.h"
 #include "xbee.h"
 #include <stdlib.h>
@@ -6,38 +40,36 @@
 #include "wl_defs.h"
 
 #ifndef ROBOT
-#include <time.h>
-#include <signal.h>
+	#include <sys/time.h>
+	#include <signal.h>
 #else
-#include <time.h>
-#ifndef FIREFLY
-#include <bom.h>
+	#include <time.h>
+	#include <bom.h>
 #endif
-#endif
 
 /*Function Prototypes*/
 
-void wl_do_timeout(void);
+static void wl_do_timeout(void);
 
 //Note: the actual frame sent has group as the first four bits and
 //frame as the last four.
-void wl_send_packet(char group, char type, char* data, int len,
-					int dest, char options, char frame);
+static int wl_send_packet(char group, char type, char* data, int len, int dest, char options, char frame);
 
 /*Data Members*/
 
 //used to store incoming and outgoing packets
-unsigned char wl_buf[128];
+//TODO: does this need to be 128?  can it be smaller to save memory?
+//TODO: this shouldn't be hardcoded as 128.  it should be a define.
+static unsigned char wl_buf[128];
 //1 if we have timed out since we last checked, 0 otherwise.
-int wl_timeout = 0;
+static int wl_timeout = 0;
 
-PacketGroupHandler* wl_packet_groups[WL_MAX_PACKET_GROUPS];
+static PacketGroupHandler* wl_packet_groups[WL_MAX_PACKET_GROUPS];
 
 #ifndef ROBOT
-timer_t wl_timeout_timer;
 
 //called when we time out, or receive interrupt
-void sig_handler(int signo)
+static void sig_handler(int signo)
 {
 	switch (signo)
 	{
@@ -51,51 +83,74 @@
 	}
 	return;
 }
+#else
+
+//called when the timer ticks
+static void timer_handler(void)
+{
+	wl_timeout = 1;
+}
+
 #endif
 
 /**
  * Initializes the wireless library. Must be called before any
  * other function.
+ *
+ * @param wl_port File descriptor for wireless port, or NULL for default.
  **/
-void wl_init()
+int wl_init()
 {
 	int i;
+  //TODO: using memset here instead of this loop, *might* be less instructions and *might* reduce code size but not sure
 	for (i = 0; i < WL_MAX_PACKET_GROUPS; i++)
 		wl_packet_groups[i] = NULL;
 
-	xbee_lib_init();
-	
+	if (xbee_lib_init() == -1) {
+		return -1;
+	}
+
 	//begin timeout timer
-	#ifdef ROBOT
-	#ifdef FIREFLY
-	rtc_init(PRESCALE_DIV_128, 32, &wl_do_timeout);
+#ifdef ROBOT
+#ifdef FIREFLY
+	rtc_init(PRESCALE_DIV_256, 32, &timer_handler);
+#else
+	//TODO: FIX THIS
+	#ifdef BAYBOARD
+	rtc_init(10 * HALF_SECOND, &timer_handler);
 	#else
-	rtc_init(HALF_SECOND, &wl_do_timeout); 
+	rtc_init(HALF_SECOND, &timer_handler);
 	#endif
-	#else
-	//create a timer to trigger every half second
-	struct sigevent evp;
-	evp.sigev_signo = SIGALRM;
-	evp.sigev_notify = SIGEV_SIGNAL;
-	if (timer_create(CLOCK_REALTIME, &evp, &wl_timeout_timer) == -1)
-	{ 
-		WL_DEBUG_PRINT("Error creating a timer.\r\n"); 
-		exit(1); 
+#endif
+#else
+
+	//create our timer
+	struct itimerval timer_val;
+	struct timeval interval;
+	interval.tv_sec = 0;
+	interval.tv_usec = 500000;
+	struct timeval first_time;
+	first_time.tv_sec = 0;
+	first_time.tv_usec = 500000;
+	timer_val.it_interval = interval;
+	timer_val.it_value = first_time;
+	if(setitimer(ITIMER_REAL,&timer_val,NULL)==-1)
+	{
+		WL_DEBUG_PRINT("Error creating a timer.\r\n");
+		perror("Failure's cause");
+		exit(1);
 	}
+
+	//create signal handler
 	struct sigaction wl_sig_act;
-	wl_sig_act.sa_handler = (void *)sig_handler;
+	wl_sig_act.sa_handler = sig_handler;
 	wl_sig_act.sa_flags = 0;
 	sigemptyset(&wl_sig_act.sa_mask);
 	sigaction(SIGALRM, &wl_sig_act, 0);
 	sigaction(SIGINT, &wl_sig_act, 0);
-	struct itimerspec wl_timeout_time;
-	wl_timeout_time.it_interval.tv_sec = 0;
-	wl_timeout_time.it_interval.tv_nsec = 500000000;
-	wl_timeout_time.it_value.tv_sec = 0;
-	wl_timeout_time.it_value.tv_nsec = 500000000;
-	timer_settime(wl_timeout_timer, 0,
-                        &wl_timeout_time, NULL);
-	#endif
+#endif
+
+	return 0;
 }
 
 /**
@@ -103,16 +158,14 @@
  **/
 void wl_terminate()
 {
-	#ifndef ROBOT
-	timer_delete(wl_timeout_timer);
-	#endif
-	
 	int i;
-	for (i = 0; i < WL_MAX_PACKET_GROUPS; i++)
+	for (i = 0; i < WL_MAX_PACKET_GROUPS; i++) {
 		if (wl_packet_groups[i] != NULL &&
-			wl_packet_groups[i]->unregister != NULL)
+			wl_packet_groups[i]->unregister != NULL) {
 			wl_packet_groups[i]->unregister();
-	
+		}
+	}
+
 	xbee_terminate();
 }
 
@@ -123,9 +176,11 @@
  *
  * @see wl_get_pan
  **/
-void wl_set_pan(int pan)
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+int wl_set_pan(int pan)
 {
-	xbee_set_pan_id(pan);
+	return xbee_set_pan_id(pan);
 }
 
 /**
@@ -135,6 +190,8 @@
  *
  * @see wl_set_pan
  **/
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
 int wl_get_pan(void)
 {
 	return xbee_get_pan_id();
@@ -147,9 +204,11 @@
  *
  * @see wl_get_channel
  **/
-void wl_set_channel(int channel)
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+int wl_set_channel(int channel)
 {
-	xbee_set_channel(channel);
+	return xbee_set_channel(channel);
 }
 
 /**
@@ -159,6 +218,8 @@
  *
  * @see wl_set_channel
  **/
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
 int wl_get_channel(void)
 {
 	return xbee_get_channel();
@@ -169,7 +230,9 @@
  *
  * @return the 16-bit address of the XBee module.
  **/
-unsigned int wl_get_xbee_id()
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+int wl_get_xbee_id()
 {
 	return xbee_get_address();
 }
@@ -184,11 +247,11 @@
  * @param dest the 16-bit address of the XBee to send the packet to
  * @param frame the frame number to see with a TX_STATUS response
  **/
-void wl_send_robot_to_robot_global_packet(char group, char type,
-		char* data, int len, int dest, char frame)
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+int wl_send_robot_to_robot_global_packet(char group, char type, char* data, int len, int dest, char frame)
 {
-	wl_send_packet(group, type, data, len, dest,
-			XBEE_OPTIONS_BROADCAST_ALL_PANS, frame);
+	return wl_send_packet(group, type, data, len, dest, XBEE_OPTIONS_BROADCAST_ALL_PANS, frame);
 }
 
 /**
@@ -201,11 +264,11 @@
  * @param dest the 16-bit address of the XBee to send the packet to
  * @param frame the frame number to see with a TX_STATUS response
  **/
-void wl_send_robot_to_robot_packet(char group, char type,
-		char* data, int len, int dest, char frame)
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+int wl_send_robot_to_robot_packet(char group, char type, char* data, int len, int dest, char frame)
 {
-	wl_send_packet(group, type, data, len, dest, XBEE_OPTIONS_NONE,
-			frame);
+	return wl_send_packet(group, type, data, len, dest, XBEE_OPTIONS_NONE, frame);
 }
 
 /**
@@ -217,11 +280,11 @@
  * @param len the packet length in bytes
  * @param frame the frame number to see with a TX_STATUS response
  **/
-void wl_send_global_packet(char group, char type,
-		char* data, int len, char frame)
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+int wl_send_global_packet(char group, char type, char* data, int len, char frame)
 {
-	wl_send_packet(group, type, data, len, XBEE_BROADCAST,
-			XBEE_OPTIONS_BROADCAST_ALL_PANS, frame);
+	return wl_send_packet(group, type, data, len, XBEE_BROADCAST, XBEE_OPTIONS_BROADCAST_ALL_PANS, frame);
 }
 
 /**
@@ -233,10 +296,11 @@
  * @param len the packet length in bytes
  * @param frame the frame number to see with a TX_STATUS response
  **/
-void wl_send_pan_packet(char group, char type,
-		char* data, int len, char frame)
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+void wl_send_pan_packet(char group, char type, char* data, int len, char frame)
 {
-	wl_send_packet(group, type, data, len, XBEE_BROADCAST, 
+	wl_send_packet(group, type, data, len, XBEE_BROADCAST,
 			XBEE_OPTIONS_NONE, frame);
 }
 
@@ -251,18 +315,21 @@
  * @param options the options for sending the packet
  * @param frame the frame number to see with a TX_STATUS response
  **/
-void wl_send_packet(char group, char type, char* data, int len,
-					int dest, char options, char frame)
+int wl_send_packet(char group, char type, char* data, int len, int dest, char options, char frame)
 {
+  //TODO: does this need to be 128?  can it be smaller to save memory?
+  //TODO: this shouldn't be hardcoded as 128.  it should be a define.
 	char buf[128];
 	int i;
 	if (frame != 0)
 		frame = (frame & 0x0F) | ((group & 0x0F) << 4);
+
 	buf[0] = group;
 	buf[1] = type;
 	for (i = 0; i < len; i++)
 		buf[2 + i] = data[i];
-	xbee_send_packet(buf, len + 2, dest, options, frame);
+
+	return xbee_send_packet(buf, len + 2, dest, options, frame);
 }
 
 /**
@@ -289,7 +356,7 @@
 
 /**
  * Unregister a packet group from the wireless library.
- * 
+ *
  * @param h the packet group to remove
  **/
 void wl_unregister_packet_group(PacketGroupHandler* h)
@@ -327,11 +394,11 @@
 		wl_do_timeout();
 		wl_timeout = 0;
 	}
-	
+
 	int len = xbee_get_packet(wl_buf);
 	if (len < 0)//no packet received
 		return;
-	
+
 	if (wl_buf[0] == XBEE_TX_STATUS)
 	{
 		if (len != 3)
@@ -339,39 +406,42 @@
 			WL_DEBUG_PRINT("Transmit Status packet should be of length 3.\r\n");
 			return;
 		}
-		
+
 		//the first four bits are the packet group
 		//this only works with under 16 groups
 		int group = (int)(wl_buf[1] >> 4);
 		int success = 0;
 		if (wl_buf[2] == 0)
+		{
 			success = 1;
+		}
 		else
 		{
 			WL_DEBUG_PRINT("No response received.\r\n");
 			if (wl_buf[2] == 2)
+			{
 				WL_DEBUG_PRINT("CCA Failure\r\n");
+			}
 			if (wl_buf[2] == 3)
+			{
 				WL_DEBUG_PRINT("Purged\r\n");
+			}
 		}
-		
-		if (wl_packet_groups[group] != NULL &&
-					wl_packet_groups[group]->handle_response != NULL)
-			wl_packet_groups[group]->handle_response(
-					(int)wl_buf[1] & 0x0F, success);
-		return;
+
+		if (wl_packet_groups[group] != NULL && wl_packet_groups[group]->handle_response != NULL)
+			wl_packet_groups[group]->handle_response((int)wl_buf[1] & 0x0F, success);
 	}
-	
-	if (wl_buf[0] == XBEE_RX)
+	else if (wl_buf[0] == XBEE_RX)
 	{
+    //TODO: what does this 7 represent?  It shouldn't be hardcoded.  It should be set as a define
 		if (len < 7)
 		{
 			WL_DEBUG_PRINT("Packet is too small.\r\n");
 			return;
 		}
-		
+
 		int source = ((int)wl_buf[1] << 8) + ((int)wl_buf[2]);
-		
+
 		/*
 		//unused for now
 		int signalStrength = wl_buf[3];
@@ -378,19 +448,31 @@
 		//1 for Address broadcast, 2 for PAN broadcast
 		int options = wl_buf[4];
 		*/
-		
+
+    //TODO: these indices, etc should be defined, not hardcoded
 		int group = wl_buf[5];
 		int type = wl_buf[6];
 		int packetLen = len - 7;
-		
-		if (wl_packet_groups[group] != NULL
-				&& wl_packet_groups[group]->handle_receive != NULL)
-			wl_packet_groups[group]->handle_receive(type, source, 
-				wl_buf + 7, packetLen);
-		return;
+
+		if (wl_packet_groups[group] != NULL && wl_packet_groups[group]->handle_receive != NULL) {
+			wl_packet_groups[group]->handle_receive(type, source, wl_buf + 7, packetLen);
+		}
 	}
-	
-	WL_DEBUG_PRINT("Unexpected packet received from XBee.\r\n");
-	return;
+	else
+	{
+		WL_DEBUG_PRINT("Unexpected packet received from XBee.\r\n");
+		printf("0x%2X\n", wl_buf[0]);
+		printf("%c%c%d\n", wl_buf[2], wl_buf[3], wl_buf[4]);
+	}
 }
 
+
+#ifndef ROBOT
+//TODO: this function is so simple, it *may* be beneficial to inline this function.  testing of if
+// it reduces code size or not should be done to be sure.
+void wl_set_com_port(char* port)
+{
+	xbee_set_com_port(port);
+}
+#endif
+
Index: branches/encoders/code/projects/libdragonfly/motor.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/motor.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/motor.c	(revision 1345)
@@ -1,14 +1,39 @@
-/*
-	motor.c - Contains functions necessary for activating and driving the 
-	H-bridge
-	
-	
-	author: Robotics Club, Colony project
-	
-	much of this is taken from FWR's library, author: Tom Lauwers
-	
-*/
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
 
+
+/**
+ * @file motor.c
+ * @brief Motors
+ *
+ * Implementation of functions for controlling the motors.
+ *
+ * @author Colony Project, CMU Robotics Club
+ * Much of this is taken from FWR's library, author: Tom Lauwers
+ **/
+
 #include "motor.h"
 
 /**
@@ -25,21 +50,21 @@
  * @see motors_off, motor1_set, motor2_set
  **/
 void motors_init( void ) {
-	// Configure counter such that we use phase correct
-	// PWM with 8-bit resolution
-	PORTA &= 0x0F;
-	DDRA |= 0xF0;
-	DDRB |= 0x60;
+  // Configure counter such that we use phase correct
+  // PWM with 8-bit resolution
+  PORTA &= 0x0F;
+  DDRA |= 0xF0;
+  DDRB |= 0x60;
 
-	//timer 1A and 1B
-	TCCR1A = _BV(COM1A1) | _BV(COM1B1) | _BV(WGM10);
-	TCCR1B = _BV(WGM12) | _BV(CS10);
-//	TCCR1A = 0xA1;
-//	TCCR1B = 0x04;
-	OCR1AH=0;
-	OCR1AL=0;
-	OCR1BH=0;
-	OCR1BL=0;
+  //timer 1A and 1B
+  TCCR1A = _BV(COM1A1) | _BV(COM1B1) | _BV(WGM10);
+  TCCR1B = _BV(WGM12) | _BV(CS10);
+  //	TCCR1A = 0xA1;
+  //	TCCR1B = 0x04;
+  OCR1AH=0;
+  OCR1AL=0;
+  OCR1BH=0;
+  OCR1BL=0;
 }
 
 /**
@@ -53,29 +78,26 @@
  **/
 void motor1_set(int direction, int speed) {
 
-	if(direction == 0) {
-	    // turn off PWM first if switching directions
-		if((PORTA & 0x30) != 0x10)
-		{
-		  OCR1A = 0;
-		}	
-		PORTA = (PORTA & 0xCF) | 0x10;
-//		PORTD |= 0x10;
-//		PORTD &= 0xBF;
-	}
-	else {
-	    // turn off PWM first if switching directions
-		if((PORTA & 0x30) != 0x20)
-		{
-		  OCR1A = 0;
-		}
-		PORTA = (PORTA & 0xCF) | 0x20;
-//		PORTD |= 0x40;
-//		PORTD &= 0xEF;
-	}
+  if(direction == 0) {
+    // turn off PWM first if switching directions
+    if((PORTA & 0x30) != 0x10) {
+      OCR1A = 0;
+    }	
+    PORTA = (PORTA & 0xCF) | 0x10;
+    //		PORTD |= 0x10;
+    //		PORTD &= 0xBF;
+  } else {
+    // turn off PWM first if switching directions
+    if((PORTA & 0x30) != 0x20) {
+      OCR1A = 0;
+    }
+    PORTA = (PORTA & 0xCF) | 0x20;
+    //		PORTD |= 0x40;
+    //		PORTD &= 0xEF;
+  }
 	
-	// Set the timer to count up to speed, an 8-bit value
-	OCR1AL = speed;
+  // Set the timer to count up to speed, an 8-bit value
+  OCR1AL = speed;
 }
 
 /**
@@ -88,30 +110,27 @@
  * @see motor1_set, motors_init
  **/
 void motor2_set(int direction, int speed) {
-	if(direction == 0) {
-//		PORTD |= 0x20;
-//		PORTD &= 0x7F;
-	    // turn off PWM first if switching directions
-		if((PORTA & 0xC0) != 0x80)
-		{
-		  OCR1B = 0;
-		}		
+  if(direction == 0) {
+    //		PORTD |= 0x20;
+    //		PORTD &= 0x7F;
+    // turn off PWM first if switching directions
+    if((PORTA & 0xC0) != 0x80) {
+      OCR1B = 0;
+    }		
 		
-		PORTA = (PORTA & 0x3F) | 0x80;
-	}
-	else {
-//		PORTD |= 0x80;
-//		PORTD &= 0xDF;
+    PORTA = (PORTA & 0x3F) | 0x80;
+  } else {
+    //		PORTD |= 0x80;
+    //		PORTD &= 0xDF;
 
-	    // turn off PWM first if switching directions
-		if((PORTA & 0xC0) != 0x40)
-		{
-		  OCR1B = 0;
-		}		
+    // turn off PWM first if switching directions
+    if((PORTA & 0xC0) != 0x40) {
+      OCR1B = 0;
+    }		
 		
-		PORTA = (PORTA & 0x3F) | 0x40;
-	}
-	OCR1BL = speed;
+    PORTA = (PORTA & 0x3F) | 0x40;
+  }
+  OCR1BL = speed;
 }
 
 /**
@@ -120,8 +139,8 @@
  * @see motors_init
  **/
 void motors_off( void ) {
-	OCR1AL = 0x0;
-	OCR1BL = 0x0;
+  OCR1AL = 0x0;
+  OCR1BL = 0x0;
 }
 
 /**@}**///end defgroup
Index: branches/encoders/code/projects/libdragonfly/motor.h
===================================================================
--- branches/encoders/code/projects/libdragonfly/motor.h	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/motor.h	(revision 1345)
@@ -1,4 +1,30 @@
 /**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
  * @file motor.h
  * @brief Contains definitions for controlling the motors
  *
Index: branches/encoders/code/projects/libdragonfly/dragonfly_lib.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/dragonfly_lib.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/dragonfly_lib.c	(revision 1345)
@@ -1,3 +1,38 @@
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
+ * @file dragonfly_lib.c
+ * @brief Dragonfly initialization
+ *
+ * Contains implementation of dragonfly_init.
+ *
+ * @author Colony Project, CMU Robotics Club
+ **/
+
 #include <dragonfly_lib.h>
 
 /* init_dragonfly - Initializes functions based on configuration parameters
@@ -27,57 +62,79 @@
  * @see analog_init, usb_init, xbee_init, buzzer_init,
  * bom_init, orb_init, motors_init, lcd_init
  **/
+ 
+void flash_red(void);
+
 void dragonfly_init(int config) 
 {
-	// Set directionality of various IO pins
-	DDRG &= ~(_BV(PING0)|_BV(PING1));
-	PORTG |= _BV(PING0)|_BV(PING1);
-	
-	if(config & ANALOG) {
-		analog_init();
-	}
-	
-	if(config & COMM) {
-    //Defaults to 115200. Check serial.h for more information.
     sei();
-    usb_init();
-    xbee_init();
-	}
-	
-	if(config & BUZZER) {
-    sei();
-		buzzer_init();
-	}
-	
-	if(config & ORB) {
-    sei();
-		orb_init();
-	}
-	
-	if(config & MOTORS) {
-		motors_init();
-	}
-	
-	if(config & SERVOS) {
-		sei();
-    //Servos not yet implemented
-    //servo_init();
-	}
+    // Set directionality of various IO pins
+    DDRG &= ~(_BV(PING0)|_BV(PING1));
+    PORTG |= _BV(PING0)|_BV(PING1);
+    
+    if(config & ANALOG)
+        analog_init(ADC_START);
+    
+    if(config & COMM)
+    {
+        //Defaults to 115200. Check serial.h for more information.
+        usb_init();
+        xbee_init();
+    }
+    
+    if(config & BUZZER)
+    {
+        sei();
+        buzzer_init();
+    }
+    
+    if(config & ORB)
+    {
+        sei();
+        orb_init();
+    }
+    
+    if(config & MOTORS)
+        motors_init();
 
-	if(config & LCD) {
-		lcd_init();
-	}
-	
-	if(config & (SERVOS | ORB)) {
+    if(config & LCD)
+        lcd_init();
+    
+    if(config & RANGE)
+        range_init();
+        
+    if(config & BOM)
+    {
+        unsigned char bom_read = get_bom_type();
+        if(bom_read == 0xFF)
+            //warn that bom initialization failed
+            flash_red();
+        else
+            bom_init(bom_read);
+    }
+    // delay a bit for stability
+    _delay_ms(1);
+}
+
+//flash lights red three times and restore ports
+void flash_red(void)
+{
+    cli();
+    char dd = DDRC;
+    char po = PORTC;
+    char i;
+    DDRC = 0x77;
+    for(i = 0; i<3; i++)
+    {
+        PORTC = 0x77;
+        delay_ms(300);
+        PORTC = 0x66;
+        delay_ms(300);
+    }
+    
+    DDRC = dd;
+    PORTC = po;
     sei();
-    orb_init();
-    //Servos not yet implemented
-	}
-	
-	// delay a bit for stability
-	_delay_ms(1);
 }
-
-
 /** @} **/ //end defgroup
 
Index: branches/encoders/code/projects/libdragonfly/i2c.c
===================================================================
--- branches/encoders/code/projects/libdragonfly/i2c.c	(revision 1344)
+++ branches/encoders/code/projects/libdragonfly/i2c.c	(revision 1345)
@@ -1,5 +1,33 @@
-/* @file i2c.c
- * @brief
+/**
+ * Copyright (c) 2007 Colony Project
+ * 
+ * Permission is hereby granted, free of charge, to any person
+ * obtaining a copy of this software and associated documentation
+ * files (the "Software"), to deal in the Software without
+ * restriction, including without limitation the rights to use,
+ * copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the
+ * Software is furnished to do so, subject to the following
+ * conditions:
+ * 
+ * The above copyright notice and this permission notice shall be
+ * included in all copies or substantial portions of the Software.
+ * 
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
+ * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
+ * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
+ * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
+ * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
+ * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
+ * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
+ * OTHER DEALINGS IN THE SOFTWARE.
+ **/
+
+
+/**
+ * @file i2c.c
+ * @brief Implemenation of I2C communications protocol
+ * 
  * In the case where you have master sends and then a master request to the same
  * address, you will not give up control of the line because the send and
  * request addresses are seen as different addresses. In between it will send a
@@ -73,6 +101,8 @@
  *								from the master
  * @param slave_send		The address of the function to call when you are a slave and the master
  *								requests data from you.
+ *
+ * @return 0 for success, nonzero for failure
  **/
 int i2c_init(char addr, fun_mrecv_t master_recv, fun_srecv_t slave_recv, fun_send_t slave_send) {
     master_recv_function = master_recv;
@@ -105,6 +135,8 @@
  * @param data 	The pointer to the byte array of data
  * @param bytes	The amount of bytes long that the byte array is. This is how
  *						many bytes from the array that the function will send.
+ *
+ * @return zero for success, nonzero for failure
  **/
 int i2c_send(char dest, char *data, size_t bytes) {
     int i;
@@ -144,6 +176,8 @@
  * to send it.
  *
  * @param dest		The destination that we want to receive information from.
+ *
+ * @return 0 for success, nonzero for failure
  **/ 
 int i2c_request(char dest) {
     if(RING_BUFFER_FULL(i2c_write_buff))
@@ -160,6 +194,8 @@
   
     return 0;
 }
+
+/** @} **/
  
 /**
  * @brief Interrupt to handle I2C interrupts from the I2C hardware.
@@ -175,7 +211,6 @@
  *
  * Errors are handled here as well.
  **/ 
- /* @} */
 ISR(TWI_vect) {
 	static char data_to_send;
 	static char addr_to_send = -1;
@@ -307,3 +342,4 @@
   /* Toggle TWINT so that it resets and executes the commands */
   TWCR |= _BV(TWINT);
 }
+
